import React, { PureComponent } from 'react';
import Tree from './secondlevel'

export default class CategoryEditor extends PureComponent
{
  constructor(props) 
  {
    super(props);

    this.Fields = this.props.Fields //["title", "subtitle", "href", "icon"]
    this.APIUrl = this.props.APIUrl //'http://localhost:3000/api/cattree';
    this.APICredentials = this.props.APICredentials //"oincdsnoce809abe97gv397vbq98bvcq";



    this.SelectedNodes = [];
    this.rootNode = {}
    this.addNodePattern = {}
    for(let i of this.Fields)
    {
      this.rootNode[i] = "No value";
      this.addNodePattern[i] = "No value";
    }

    this.myTree = React.createRef();

     this.buttonStyle = {
      backgroundColor:"#2FAF27", 
      borderRadius:6, 
      padding:"5px 30px 5px 30px", 
      fontFamily:"Arial", 
      color:"#3A1A08", 
      cursor:"pointer", 
      userSelect:"none",
      margin:"5px 5px 0px 5px"
    }

    this.inputStyle={
      borderRadius: 8,
      border:"1px solid #d6d6d6",
      fontSize:"0.857rem",
      lineHeight:"1.833",
      padding:"9px 10px 8px",
      width:"100%",
      marginLeft:8,
      color:"#2D2D2D",
    }


  }


  render()
  { 
    this.InputParameters = {};
    return <div style={{display:"flex", flexDirection:"row", height:"100vh", width:"100vw"}}>

           
            <div style={{height:"100vh", minWidth:500, width:"50%"}}>
                <Tree
                  ref={this.myTree}
                  rootNode={this.rootNode} 
                  addNodePattern={this.addNodePattern} 
                  onNodesSelect = {(arr)=>
                    {
                      this.SelectedNodes = arr;
                       this.forceUpdate(); //this have to be run in this method, otherwise component will not work at all;
                    }}
                />
            </div>

            <div style={{display:"flex", justifyContent:"center", alignItems:"center", height:"100vh", minWidth:500, width:"50%"}}>

              <div style={{width:350, backgroundColor:"#BADBB8", borderRadius:10, paddingBottom:10}}>

                  {
                    
                    this.SelectedNodes.length > 0?Object.keys(this.SelectedNodes[0]).map((key)=>{
                      this.InputParameters[key] = this.SelectedNodes[0][key];
                      if(key == "children") return null;
                      if(key == "expanded") return null;
                      if(key == "selected") return null;
                      if(key == "id") return null;
                      return   <div key={key} style={{display:"flex", flexDirection:"row", fontFamily:"Arial", padding:"5px 20px 10px 20px"}}>
                          <span style={{paddingTop:13, width:100}}>{key+":"}</span>
                          <input key={new Date().getMilliseconds()} style={this.inputStyle} defaultValue={this.SelectedNodes[0][key]} 
                          onChange={(val)=>{this.InputParameters[key] = val.target.value; }}/>
                      </div>
                    }):null
                  }


                <div style={{display:"flex", justifyContent:"space-evenly", flexDirection:"row"}}>
                  <div style={this.buttonStyle} onClick={()=>{this.myTree.current.AddNode();}}>Add</div>
                  <div style={this.buttonStyle} onClick={()=>{this.myTree.current.DeleteNode()}}>Delete</div>
                  <div style={this.buttonStyle} onClick={()=>{this.myTree.current.Replace(this.InputParameters)}}>Replace</div>
                </div>

                <div style={{...this.buttonStyle,display:"flex", justifyContent:"center", backgroundColor:"#00B5FF"}}
                onClick={()=>
                {
                  fetch(this.APIUrl, {
                                  method: 'POST',
                                  headers: {
                                    'Accept': 'application/json',
                                    'Content-Type': 'application/json',
                                  },
                                  body: JSON.stringify({Command:"Write", Credentials:this.APICredentials, Data:this.myTree.current.treeData})
                                }).then((r) => r.json()).then((res) => 
                                {
                                  console.log(res);
                                }).catch(err=>{
                                  console.error("Error:",err);
                                });

                   
                }}>
                  Save
                </div>
                <div style={{...this.buttonStyle,display:"flex", justifyContent:"center", backgroundColor:"#008855"}}
                onClick={()=>{
                  fetch(this.APIUrl, {
                                  method: 'POST',
                                  headers: {
                                    'Accept': 'application/json',
                                    'Content-Type': 'application/json',
                                  },
                                  body: JSON.stringify({Command:'Read'})
                                }).then((r) => r.json()).then((res) => 
                                {
                                  this.myTree.current.treeData = res;
                                  this.forceUpdate();
                                }).catch(err=>{
                                  console.error("Error:",err);
                                })
                }}>
                  Read
                </div>

              </div>

            </div>

          </div>
  }
}
